commit 9b6fadfc272c9a8941ca245c40fd22c9be66d112
Author: jklowden <jklowden>
Date:   Wed May 28 13:44:19 2008 +0000

    reset getopt(3) portably

diff --git a/ChangeLog b/ChangeLog
index 2cc0fb7..dc9ff25 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed May 28 09:41:16 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* configure.ac src/apps/tsql.c  
+	- reset getopt(3) portably
+
 Tue May 27 18:21:46 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* include/tds.h include arpa/inet.h
 
@@ -309,4 +313,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2526 2008/05/27 22:24:48 jklowden Exp $
+$Id: ChangeLog,v 1.2527 2008/05/28 13:44:19 jklowden Exp $
diff --git a/configure.ac b/configure.ac
index 308c930..1e37fdf 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.36 2008/05/15 15:49:52 jklowden Exp $
+dnl $Id: configure.ac,v 1.37 2008/05/28 13:44:19 jklowden Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.36 $)
+AC_REVISION($Revision: 1.37 $)
 
 AM_INIT_AUTOMAKE
 AC_CONFIG_HEADERS(include/config.h)
@@ -240,7 +240,7 @@ AC_CHECK_MEMBERS([struct tm.__tm_zone],,,[#include <sys/types.h>
 ])
 AC_CHECK_HEADERS([unistd.h errno.h wchar.h sys/time.h sys/types.h \
 sys/param.h sys/stat.h sys/wait.h limits.h locale.h odbcss.h readpassphrase.h \
-signal.h libgen.h poll.h])
+signal.h libgen.h poll.h getopt.h])
 if test $tds_mingw = no; then
 	AC_CHECK_HEADERS([sys/socket.h arpa/inet.h netdb.h netinet/in.h \
 netinet/tcp.h paths.h sys/ioctl.h langinfo.h])
@@ -347,6 +347,16 @@ AC_EGREP_CPP(yes,
 
 TYPE_SOCKLEN_T
 
+AC_MSG_CHECKING([whether getopt has optreset support])
+AC_TRY_LINK([#ifdef HAVE_GETOPT_H
+#include <getopt.h>
+#endif], [extern int optreset; optreset = 0;],
+[AC_MSG_RESULT(yes)
+AC_DEFINE(HAVE_GETOPT_OPTRESET, 1, [Define if your getopt(3) defines and uses optreset])],
+[AC_MSG_RESULT(no)]
+)
+
+
 # ------------------------------------------------------------
 # Checks for compiler characteristics.
 # ------------------------------------------------------------
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index c394745..cb4ae36 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.115 2008/05/27 08:25:04 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.116 2008/05/28 13:44:19 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -303,6 +303,15 @@ tsql_print_usage(const char *progname)
 		progname, progname);
 }
 
+static int
+reset_getopt(void)
+{
+#ifdef HAVE_GETOPT_OPTRESET
+	optreset = 1;
+#endif
+	optind = 1;
+}
+
 /*
  * The 'GO' command may be followed by options that apply to the batch.
  * If they don't appear to be right, assume the letters "go" are part of the
@@ -326,7 +335,7 @@ get_opt_flags(char *s, int *opt_flags)
 		s = NULL;
 
 	*opt_flags = 0;
-	optind = 0;		/* reset getopt */
+	reset_getopt();
 	opterr = 0;		/* suppress error messages */
 	while ((opt = getopt(argc, argv, "fhqtv")) != -1) {
 		switch (opt) {

